/*******************************************************************************
 *  Copyright CONSORTIUM COCKTAIL (www.cocktail.org), 1995, 2008
 *  
 *  This software is governed by the CeCILL license under French law and abiding
 *  by the rules of distribution of free software. You can use, modify and/or
 *  redistribute the software under the terms of the CeCILL license as circulated
 *  by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".
 *  
 *  As a counterpart to the access to the source code and rights to copy, modify
 *  and redistribute granted by the license, users are provided only with a
 *  limited warranty and the software's author, the holder of the economic
 *  rights, and the successive licensors have only limited liability.
 *  
 *  In this respect, the user's attention is drawn to the risks associated with
 *  loading, using, modifying and/or developing or reproducing the software by
 *  the user in light of its specific status of free software, that may mean that
 *  it is complicated to manipulate, and that also therefore means that it is
 *  reserved for developers and experienced professionals having in-depth
 *  computer knowledge. Users are therefore encouraged to load and test the
 *  software's suitability as regards their requirements in conditions enabling
 *  the security of their systems and/or data to be ensured and, more generally,
 *  to use and operate it in the same conditions as regards security.
 *  
 *  The fact that you are presently reading this means that you have had
 *  knowledge of the CeCILL license and that you accept its terms.
 * 
 *******************************************************************************/

package org.cocktail.kiwi.client.nibctrl;

import java.awt.BorderLayout;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.kiwi.client.ApplicationIcones;
import org.cocktail.kiwi.client.metier.EOIndemnite;
import org.cocktail.kiwi.common.utilities.CocktailConstantes;
import org.cocktail.kiwi.common.utilities.CocktailIcones;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class IndemnitesView extends javax.swing.JPanel {

	protected EODisplayGroup eodIndemnite, eodCalculAuto, eodTarif;

	protected ZEOTable myEOTableIndemnite, myEOTableCalculAuto, myEOTableTarif;
	protected ZEOTableModel myTableModelIndemnite, myTableModelCalculAuto, myTableModelTarif ;
	protected TableSorter myTableSorterIndemnite, myTableSorterCalculAuto, myTableSorterTarif;

    /** Creates new form TemplateJPanel */
    public IndemnitesView(EODisplayGroup dgIndemnite, EODisplayGroup dgCalculAuto, EODisplayGroup dgTarif) {

        eodIndemnite = dgIndemnite;
        eodCalculAuto = dgCalculAuto;
        eodTarif = dgTarif;
        
        initComponents();
        initGui();
        
    }


	/** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewTableIndemnites = new javax.swing.JPanel();
        viewTableCalculAuto = new javax.swing.JPanel();
        btnModifier = new javax.swing.JButton();
        btnRecalculer = new javax.swing.JButton();
        btnSupprimer = new javax.swing.JButton();
        btnSasie = new javax.swing.JButton();
        jLabel3 = new javax.swing.JLabel();
        viewTableTarif = new javax.swing.JPanel();
        jLabel4 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        btnAjouter = new javax.swing.JButton();

        viewTableIndemnites.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        viewTableIndemnites.setLayout(new java.awt.BorderLayout());

        viewTableCalculAuto.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        viewTableCalculAuto.setLayout(new java.awt.BorderLayout());

        btnModifier.setToolTipText("Modifier l'indemnité");

        btnRecalculer.setToolTipText("Recalculer les indemnités par défaut");

        btnSupprimer.setToolTipText("Supprimer l'indemnité");

        btnSasie.setToolTipText("Effectuer une saisie manuelle du montant");

        jLabel3.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel3.setForeground(new java.awt.Color(153, 153, 255));
        jLabel3.setText("Résultat du calcul automatique");

        viewTableTarif.setBorder(javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
        viewTableTarif.setLayout(new java.awt.BorderLayout());

        jLabel4.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel4.setForeground(new java.awt.Color(153, 153, 255));
        jLabel4.setText("Zone indemnité pour ce trajet");

        jLabel5.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel5.setForeground(new java.awt.Color(153, 153, 153));
        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel5.setText("Rappel : 1 Nuit = 65% d'une indemnité   1 Repas = 17,5%");

        btnAjouter.setToolTipText("Ajouter une indemnité");

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(viewTableIndemnites, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 657, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                                    .add(btnRecalculer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(btnModifier, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(btnSasie, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(btnSupprimer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                            .add(btnAjouter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(viewTableCalculAuto, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 713, Short.MAX_VALUE)
                    .add(layout.createSequentialGroup()
                        .add(jLabel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 293, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 78, Short.MAX_VALUE)
                        .add(jLabel5, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 342, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(jLabel4, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 709, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(viewTableTarif, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 713, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(layout.createSequentialGroup()
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(btnModifier, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(btnSupprimer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                                    .add(btnRecalculer, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .add(btnSasie, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                            .add(viewTableIndemnites, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 75, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(jLabel3)
                            .add(jLabel5))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(viewTableCalculAuto, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 43, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel4)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(viewTableTarif, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 50, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(btnAjouter, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 22, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents


    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAjouter;
    private javax.swing.JButton btnModifier;
    private javax.swing.JButton btnRecalculer;
    private javax.swing.JButton btnSasie;
    private javax.swing.JButton btnSupprimer;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    protected javax.swing.JPanel viewTableCalculAuto;
    protected javax.swing.JPanel viewTableIndemnites;
    protected javax.swing.JPanel viewTableTarif;
    // End of variables declaration//GEN-END:variables

    
    
    
    private void initGui() {
            
    	btnAjouter.setIcon(CocktailIcones.ICON_ADD);
    	btnModifier.setIcon(CocktailIcones.ICON_UPDATE);
    	btnSupprimer.setIcon(CocktailIcones.ICON_DELETE);
    	btnRecalculer.setIcon(ApplicationIcones.ICON_RELOAD);
    	btnSasie.setIcon(CocktailIcones.ICON_WIZARD_16);
    	
    	Vector myCols = new Vector();

		ZEOTableModelColumn col= new ZEOTableModelColumn(eodIndemnite, EOIndemnite.IND_JOURS_KEY, "Indemnités", 110);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col= new ZEOTableModelColumn(eodIndemnite, EOIndemnite.IND_NB_NUITS_KEY, "Nuits", 85);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col= new ZEOTableModelColumn(eodIndemnite, EOIndemnite.IND_NB_REPAS_KEY, "Repas", 85);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodIndemnite, EOIndemnite.IND_NUITS_GRATUITES_KEY, "Nuits Gratuites", 85);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodIndemnite, EOIndemnite.IND_REPAS_GRATUITS_KEY, "Repas Gratuits", 85);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);		
		col = new ZEOTableModelColumn(eodIndemnite, "stringTarifIndemnite", "Tarif Indemnité", 130);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodIndemnite, EOIndemnite.IND_MONTANT_PAIEMENT_KEY, "Montant", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);

		myTableModelIndemnite = new ZEOTableModel(eodIndemnite, myCols);
		myTableSorterIndemnite = new TableSorter(myTableModelIndemnite);

		myEOTableIndemnite = new ZEOTable(myTableSorterIndemnite);
		//myEOTableIndemnite.addListener(myListenerContrat);
		myTableSorterIndemnite.setTableHeader(myEOTableIndemnite.getTableHeader());		

		myEOTableIndemnite.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableIndemnite.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableIndemnite.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableIndemnites.setLayout(new BorderLayout());
		viewTableIndemnites.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableIndemnites.removeAll();
		viewTableIndemnites.add(new JScrollPane(myEOTableIndemnite), BorderLayout.CENTER);

		myCols = new Vector();

		col= new ZEOTableModelColumn(eodCalculAuto, EOIndemnite.IND_JOURS_AUTO_KEY, "Indemnités", 110);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col= new ZEOTableModelColumn(eodCalculAuto, EOIndemnite.IND_NUITS_AUTO_KEY, "Nuits", 85);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodCalculAuto, EOIndemnite.IND_REPAS_AUTO_KEY, "Repas", 130);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodCalculAuto, EOIndemnite.IND_MONTANT_AUTO_KEY, "Montant Auto", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodIndemnite, EOIndemnite.IND_MONTANT_SAISI_KEY, "Montant Saisi", 75);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);

		
		myTableModelCalculAuto = new ZEOTableModel(eodCalculAuto, myCols);
		myTableSorterCalculAuto = new TableSorter(myTableModelCalculAuto);

		myEOTableCalculAuto = new ZEOTable(myTableSorterCalculAuto);
		//myEOTableIndemnite.addListener(myListenerContrat);
		myTableSorterCalculAuto.setTableHeader(myEOTableCalculAuto.getTableHeader());		

		myEOTableCalculAuto.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableCalculAuto.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableCalculAuto.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableCalculAuto.setLayout(new BorderLayout());
		viewTableCalculAuto.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableCalculAuto.removeAll();
		viewTableCalculAuto.add(new JScrollPane(myEOTableCalculAuto), BorderLayout.CENTER);

 
		
		myCols = new Vector();

		col = new ZEOTableModelColumn(eodTarif, "wmiGroupe1", "Groupe 1", 110);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodTarif, "wmiGroupe2", "Groupe 2", 110);
		col.setAlignment(SwingConstants.CENTER);
		//		myCols.add(col);
		col = new ZEOTableModelColumn(eodTarif, "wmiGroupe3", "Groupe 3", 110);
		col.setAlignment(SwingConstants.CENTER);
		//		myCols.add(col);
		col = new ZEOTableModelColumn(eodTarif, "wmiDebut", "Début", 90);
		col.setFormatDisplay((DateFormat)new SimpleDateFormat("dd/MM/yyyy"));
		myCols.add(col);
		col.setAlignment(SwingConstants.CENTER);
		col = new ZEOTableModelColumn(eodTarif, "wmiFin", "Fin", 90);
		col.setFormatDisplay((DateFormat)new SimpleDateFormat("dd/MM/yyyy"));
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eodTarif, "webmon.devises.llDevise", "Devise", 200);
		col.setAlignment(SwingConstants.RIGHT);
		myCols.add(col);
		
		myTableModelTarif = new ZEOTableModel(eodTarif, myCols);
		myTableSorterTarif = new TableSorter(myTableModelTarif);

		myEOTableTarif = new ZEOTable(myTableSorterTarif);
		//myEOTableTarif.addListener(myListenerContrat);
		myTableSorterTarif.setTableHeader(myEOTableTarif.getTableHeader());		

		myEOTableTarif.setBackground(CocktailConstantes.COLOR_BKG_TABLE_VIEW);
		myEOTableTarif.setSelectionBackground(CocktailConstantes.COLOR_SELECTED_ROW);
		myEOTableTarif.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTableTarif.setLayout(new BorderLayout());
		viewTableTarif.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTableTarif.removeAll();
		viewTableTarif.add(new JScrollPane(myEOTableTarif), BorderLayout.CENTER);


    }


	public ZEOTableModel getMyTableModelTarif() {
		return myTableModelTarif;
	}


	public void setMyTableModelTarif(ZEOTableModel myTableModelTarif) {
		this.myTableModelTarif = myTableModelTarif;
	}


	public ZEOTableModel getMyTableModelCalculAuto() {
		return myTableModelCalculAuto;
	}


	public void setMyTableModelCalculAuto(ZEOTableModel myTableModelCalculAuto) {
		this.myTableModelCalculAuto = myTableModelCalculAuto;
	}


	public ZEOTableModel getMyTableModelIndemnite() {
		return myTableModelIndemnite;
	}


	public void setMyTableModelIndemnite(ZEOTableModel myTableModelIndemnite) {
		this.myTableModelIndemnite = myTableModelIndemnite;
	}


	public ZEOTable getMyEOTableIndemnite() {
		return myEOTableIndemnite;
	}


	public void setMyEOTableIndemnite(ZEOTable myEOTableIndemnite) {
		this.myEOTableIndemnite = myEOTableIndemnite;
	}


	public ZEOTable getMyEOTableCalculAuto() {
		return myEOTableCalculAuto;
	}


	public void setMyEOTableCalculAuto(ZEOTable myEOTableCalculAuto) {
		this.myEOTableCalculAuto = myEOTableCalculAuto;
	}


	public ZEOTable getMyEOTableTarif() {
		return myEOTableTarif;
	}


	public void setMyEOTableTarif(ZEOTable myEOTableTarif) {
		this.myEOTableTarif = myEOTableTarif;
	}


	public javax.swing.JButton getBtnAjouter() {
		return btnAjouter;
	}


	public void setBtnAjouter(javax.swing.JButton btnAjouter) {
		this.btnAjouter = btnAjouter;
	}


	public javax.swing.JButton getBtnModifier() {
		return btnModifier;
	}


	public void setBtnModifier(javax.swing.JButton btnModifier) {
		this.btnModifier = btnModifier;
	}


	public javax.swing.JButton getBtnRecalculer() {
		return btnRecalculer;
	}


	public void setBtnRecalculer(javax.swing.JButton btnRecalculer) {
		this.btnRecalculer = btnRecalculer;
	}


	public javax.swing.JButton getBtnSasie() {
		return btnSasie;
	}


	public void setBtnSasie(javax.swing.JButton btnSasie) {
		this.btnSasie = btnSasie;
	}


	public javax.swing.JButton getBtnSupprimer() {
		return btnSupprimer;
	}


	public void setBtnSupprimer(javax.swing.JButton btnSupprimer) {
		this.btnSupprimer = btnSupprimer;
	}
    
}
